JarURLConnection (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.net, class: JarURLConnection
Keywords: java.net.JarURLConnection class

# Class JarURLConnection

java.lang.Object
java.net.URLConnection
java.net.JarURLConnection

public abstract class JarURLConnection extends URLConnection
A URL Connection to a Java ARchive (JAR) file or an entry in a JAR file.

The syntax of a JAR URL is:

    jar:<url>!/{entry}

for example:

`jar:http://www.foo.com/bar/baz.jar!/COM/foo/Quux.class`

Jar URLs should be used to refer to a JAR file or entries in a JAR file. The example above is a JAR URL which refers to a JAR entry. If the entry name is omitted, the URL refers to the whole JAR file: `jar:http://www.foo.com/bar/baz.jar!/`

Users should cast the generic URLConnection to a JarURLConnection when they know that the URL they created is a JAR URL, and they need JAR-specific functionality. For example:

    URL url = new URL("jar:file:/home/duke/duke.jar!/");
    JarURLConnection jarConnection = (JarURLConnection)url.openConnection();
    Manifest manifest = jarConnection.getManifest();

JarURLConnection instances can only be used to read from JAR files. It is not possible to get a `OutputStream` to modify or write to the underlying JAR file using this class.

Examples:

A Jar entry
  `jar:http://www.foo.com/bar/baz.jar!/COM/foo/Quux.class`
A Jar file
  `jar:http://www.foo.com/bar/baz.jar!/`
A Jar directory
  `jar:http://www.foo.com/bar/baz.jar!/COM/foo/`

`!/` is referred to as the separator.

When constructing a JAR url via `new URL(context, spec)`, the following rules apply:

- if there is no context URL and the specification passed to the URL constructor doesn't contain a separator, the URL is considered to refer to a JarFile.
- if there is a context URL, the context URL is assumed to refer to a JAR file or a Jar directory.
- if the specification begins with a '/', the Jar directory is ignored, and the spec is considered to be at the root of the Jar file.

  Examples:

  context: jar:http://www.foo.com/bar/jar.jar!/, spec:baz/entry.txt
    url:jar:http://www.foo.com/bar/jar.jar!/baz/entry.txt
  context: jar:http://www.foo.com/bar/jar.jar!/baz, spec:entry.txt
    url:jar:http://www.foo.com/bar/jar.jar!/baz/entry.txt
  context: jar:http://www.foo.com/bar/jar.jar!/baz, spec:/entry.txt
    url:jar:http://www.foo.com/bar/jar.jar!/entry.txt

Since:
  1.2
See Also:
  - `URL`
  - `URLConnection`
  - `JarFile`
  - `JarInputStream`
  - `Manifest`
  - `ZipEntry`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected URLConnection`
  `jarFileURLConnection`
  The connection to the JAR file URL, if the connection has been initiated.

  ### Fields declared in class URLConnection

  `allowUserInteraction, connected, doInput, doOutput, ifModifiedSince, url, useCaches`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `allowUserInteraction`
  If `true`, this `URL` is being examined in a context in which it makes sense to allow user interactions such as popping up an authentication dialog.
  `protected boolean`
  `connected`
  If `false`, this connection object has not created a communications link to the specified URL.
  `protected boolean`
  `doInput`
  This variable is set by the `setDoInput` method.
  `protected boolean`
  `doOutput`
  This variable is set by the `setDoOutput` method.
  `protected long`
  `ifModifiedSince`
  Some protocols support skipping the fetching of the object unless the object has been modified more recently than a certain time.
  `protected URL`
  `url`
  The URL represents the remote object on the World Wide Web to which this connection is opened.
  `protected boolean`
  `useCaches`
  If `true`, the protocol is allowed to use caching whenever it can.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `JarURLConnection(URL url)`
  Creates the new JarURLConnection to the specified URL.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Attributes`
  `getAttributes()`
  Return the Attributes object for this connection if the URL for it points to a JAR file entry, null otherwise.
  `Certificate[]`
  `getCertificates()`
  Returns the Certificate objects for this connection if the URL for it points to a JAR file entry, null otherwise.
  `String`
  `getEntryName()`
  Return the entry name for this connection.
  `JarEntry`
  `getJarEntry()`
  Return the JAR entry object for this connection, if any.
  `abstract JarFile`
  `getJarFile()`
  Return the JAR file for this connection.
  `URL`
  `getJarFileURL()`
  Returns the URL for the Jar file for this connection.
  `Attributes`
  `getMainAttributes()`
  Returns the main Attributes for the JAR file for this connection.
  `Manifest`
  `getManifest()`
  Returns the Manifest for this connection, or null if none.

  ### Methods declared in class URLConnection

  `addRequestProperty, connect, getAllowUserInteraction, getConnectTimeout, getContent, getContent, getContentEncoding, getContentLength, getContentLengthLong, getContentType, getDate, getDefaultAllowUserInteraction, getDefaultRequestProperty, getDefaultUseCaches, getDefaultUseCaches, getDoInput, getDoOutput, getExpiration, getFileNameMap, getHeaderField, getHeaderField, getHeaderFieldDate, getHeaderFieldInt, getHeaderFieldKey, getHeaderFieldLong, getHeaderFields, getIfModifiedSince, getInputStream, getLastModified, getOutputStream, getPermission, getReadTimeout, getRequestProperties, getRequestProperty, getURL, getUseCaches, guessContentTypeFromName, guessContentTypeFromStream, setAllowUserInteraction, setConnectTimeout, setContentHandlerFactory, setDefaultAllowUserInteraction, setDefaultRequestProperty, setDefaultUseCaches, setDefaultUseCaches, setDoInput, setDoOutput, setFileNameMap, setIfModifiedSince, setReadTimeout, setRequestProperty, setUseCaches, toString`
  Modifier and Type
  Method
  Description
  `void`
  `addRequestProperty(String key, String value)`
  Adds a general request property specified by a key-value pair.
  `abstract void`
  `connect()`
  Opens a communications link to the resource referenced by this URL, if such a connection has not already been established.
  `boolean`
  `getAllowUserInteraction()`
  Returns the value of the `allowUserInteraction` field for this object.
  `int`
  `getConnectTimeout()`
  Returns setting for connect timeout.
  `Object`
  `getContent()`
  Retrieves the contents of this URL connection.
  `Object`
  `getContent(Class<?>[] classes)`
  Retrieves the contents of this URL connection.
  `String`
  `getContentEncoding()`
  Returns the value of the `content-encoding` header field.
  `int`
  `getContentLength()`
  Returns the value of the `content-length` header field.
  `long`
  `getContentLengthLong()`
  Returns the value of the `content-length` header field as a long.
  `String`
  `getContentType()`
  Returns the value of the `content-type` header field.
  `long`
  `getDate()`
  Returns the value of the `date` header field.
  `static boolean`
  `getDefaultAllowUserInteraction()`
  Returns the default value of the `allowUserInteraction` field.
  `static String`
  `getDefaultRequestProperty(String key)`
  Deprecated.
  The instance specific getRequestProperty method should be used after an appropriate instance of URLConnection is obtained.
  `boolean`
  `getDefaultUseCaches()`
  Returns the default value of a `URLConnection`'s `useCaches` flag.
  `static boolean`
  `getDefaultUseCaches(String protocol)`
  Returns the default value of the `useCaches` flag for the given protocol.
  `boolean`
  `getDoInput()`
  Returns the value of this `URLConnection`'s `doInput` flag.
  `boolean`
  `getDoOutput()`
  Returns the value of this `URLConnection`'s `doOutput` flag.
  `long`
  `getExpiration()`
  Returns the value of the `expires` header field.
  `static FileNameMap`
  `getFileNameMap()`
  Loads filename map (a mimetable) from a data file.
  `String`
  `getHeaderField(int n)`
  Returns the value for the `n`th header field.
  `String`
  `getHeaderField(String name)`
  Returns the value of the named header field.
  `long`
  `getHeaderFieldDate(String name, long defaultValue)`
  Returns the value of the named field parsed as date.
  `int`
  `getHeaderFieldInt(String name, int defaultValue)`
  Returns the value of the named field parsed as a number.
  `String`
  `getHeaderFieldKey(int n)`
  Returns the key for the `n`th header field.
  `long`
  `getHeaderFieldLong(String name, long defaultValue)`
  Returns the value of the named field parsed as a number.
  `Map<String, List<String>>`
  `getHeaderFields()`
  Returns an unmodifiable Map of the header fields.
  `long`
  `getIfModifiedSince()`
  Returns the value of this object's `ifModifiedSince` field.
  `InputStream`
  `getInputStream()`
  Returns an input stream that reads from this open connection.
  `long`
  `getLastModified()`
  Returns the value of the `last-modified` header field.
  `OutputStream`
  `getOutputStream()`
  Returns an output stream that writes to this connection.
  `Permission`
  `getPermission()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Permissions can no longer be used for controlling access to resources as the Security Manager is no longer supported.
  `int`
  `getReadTimeout()`
  Returns setting for read timeout. 0 return implies that the option is disabled (i.e., timeout of infinity).
  `Map<String, List<String>>`
  `getRequestProperties()`
  Returns an unmodifiable Map of general request properties for this connection.
  `String`
  `getRequestProperty(String key)`
  Returns the value of the named general request property for this connection.
  `URL`
  `getURL()`
  Returns the value of this `URLConnection`'s `URL` field.
  `boolean`
  `getUseCaches()`
  Returns the value of this `URLConnection`'s `useCaches` field.
  `static String`
  `guessContentTypeFromName(String fname)`
  Tries to determine the content type of an object, based on the specified "file" component of a URL.
  `static String`
  `guessContentTypeFromStream(InputStream is)`
  Tries to determine the type of an input stream based on the characters at the beginning of the input stream.
  `void`
  `setAllowUserInteraction(boolean allowuserinteraction)`
  Set the value of the `allowUserInteraction` field of this `URLConnection`.
  `void`
  `setConnectTimeout(int timeout)`
  Sets a specified timeout value, in milliseconds, to be used when opening a communications link to the resource referenced by this URLConnection.
  `static void`
  `setContentHandlerFactory(ContentHandlerFactory fac)`
  Sets the `ContentHandlerFactory` of an application.
  `static void`
  `setDefaultAllowUserInteraction(boolean defaultallowuserinteraction)`
  Sets the default value of the `allowUserInteraction` field for all future `URLConnection` objects to the specified value.
  `static void`
  `setDefaultRequestProperty(String key, String value)`
  Deprecated.
  The instance specific setRequestProperty method should be used after an appropriate instance of URLConnection is obtained.
  `void`
  `setDefaultUseCaches(boolean defaultusecaches)`
  Sets the default value of the `useCaches` field to the specified value.
  `static void`
  `setDefaultUseCaches(String protocol, boolean defaultVal)`
  Sets the default value of the `useCaches` field for the named protocol to the given value.
  `void`
  `setDoInput(boolean doinput)`
  Sets the value of the `doInput` field for this `URLConnection` to the specified value.
  `void`
  `setDoOutput(boolean dooutput)`
  Sets the value of the `doOutput` field for this `URLConnection` to the specified value.
  `static void`
  `setFileNameMap(FileNameMap map)`
  Sets the FileNameMap.
  `void`
  `setIfModifiedSince(long ifmodifiedsince)`
  Sets the value of the `ifModifiedSince` field of this `URLConnection` to the specified value.
  `void`
  `setReadTimeout(int timeout)`
  Sets the read timeout to a specified timeout, in milliseconds.
  `void`
  `setRequestProperty(String key, String value)`
  Sets the general request property.
  `void`
  `setUseCaches(boolean usecaches)`
  Sets the value of the `useCaches` field of this `URLConnection` to the specified value.
  `String`
  `toString()`
  Returns a `String` representation of this URL connection.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### jarFileURLConnection

    protected URLConnection jarFileURLConnection
    The connection to the JAR file URL, if the connection has been initiated. This should be set by connect.

- ## Constructor Details

  - ### JarURLConnection

    protected JarURLConnection(URL url) throws MalformedURLException
    Creates the new JarURLConnection to the specified URL.
    Parameters:
      `url` - the URL
    Throws:
      `MalformedURLException` - if no legal protocol could be found in a specification string or the string could not be parsed.

- ## Method Details

  - ### getJarFileURL

    public URL getJarFileURL()
    Returns the URL for the Jar file for this connection.
    Returns:
      the URL for the Jar file for this connection.

  - ### getEntryName

    public String getEntryName()
    Return the entry name for this connection. This method returns null if the JAR file URL corresponding to this connection points to a JAR file and not a JAR file entry.
    Returns:
      the entry name for this connection, if any.

  - ### getJarFile

    public abstract JarFile getJarFile() throws IOException
    Return the JAR file for this connection.
    Returns:
      the JAR file for this connection. If the connection is a connection to an entry of a JAR file, the JAR file object is returned
    Throws:
      `IOException` - if an IOException occurs while trying to connect to the JAR file for this connection.
    See Also:
      - `URLConnection.connect()`

  - ### getManifest

    public Manifest getManifest() throws IOException
    Returns the Manifest for this connection, or null if none.
    Returns:
      the manifest object corresponding to the JAR file object for this connection.
    Throws:
      `IOException` - if getting the JAR file for this connection causes an IOException to be thrown.
    See Also:
      - `getJarFile()`

  - ### getJarEntry

    public JarEntry getJarEntry() throws IOException
    Return the JAR entry object for this connection, if any. This method returns null if the JAR file URL corresponding to this connection points to a JAR file and not a JAR file entry.
    Returns:
      the JAR entry object for this connection, or null if the JAR URL for this connection points to a JAR file.
    Throws:
      `IOException` - if getting the JAR file for this connection causes an IOException to be thrown.
    See Also:
      - `getJarFile()`
      - `getJarEntry()`

  - ### getAttributes

    public Attributes getAttributes() throws IOException
    Return the Attributes object for this connection if the URL for it points to a JAR file entry, null otherwise.
    Returns:
      the Attributes object for this connection if the URL for it points to a JAR file entry, null otherwise.
    Throws:
      `IOException` - if getting the JAR entry causes an IOException to be thrown.
    See Also:
      - `getJarEntry()`

  - ### getMainAttributes

    public Attributes getMainAttributes() throws IOException
    Returns the main Attributes for the JAR file for this connection.
    Returns:
      the main Attributes for the JAR file for this connection.
    Throws:
      `IOException` - if getting the manifest causes an IOException to be thrown.
    See Also:
      - `getJarFile()`
      - `getManifest()`

  - ### getCertificates

    public Certificate[] getCertificates() throws IOException
    Returns the Certificate objects for this connection if the URL for it points to a JAR file entry, null otherwise. This method can only be called once the connection has been completely verified by reading from the input stream until the end of the stream has been reached. Otherwise, this method will return `null`.

    The returned certificate array comprises all the signer certificates that were used to verify this entry. Each signer certificate is followed by its supporting certificate chain (which may be empty). Each signer certificate and its supporting certificate chain are ordered bottom-to-top (i.e., with the signer certificate first and the (root) certificate authority last).

    API Note:
      The verification process does not include validating or establishing trust in the code signers. A caller should perform additional checks, such as using a `CertPathValidator` to validate each signer's certificate chain, and determining whether to trust the entry signed by the signers.
    Returns:
      the Certificate objects for this connection if the URL for it points to a JAR file entry, null otherwise.
    Throws:
      `IOException` - if getting the JAR entry causes an IOException to be thrown.
    See Also:
      - `getJarEntry()`